class Spoke {
  
  // Location and size
  float x;
  float y;
  float r;
  
  // An AudioPlayer object is used to store the sound.
  AudioSnippet dingdong; 
  
  // Create the doorbell
  Spoke (float x_, float y_, float r_, String filename) {
    x = x_;
    y = y_;
    r = r_;
    
    // load "dingdong1.mp3 etc." into a new AudioPlayer
    dingdong = minim.loadSnippet(filename);
  }

  // The spoke rings!
  void ring() {
    if (!dingdong.isPlaying()) {
      // The ring() function plays the sound, as long as it is not already playing. 
      // rewind() ensures the sound starts from the beginning.
      dingdong.rewind(); 
      dingdong.play();
    }
  }

  // Is a point inside the spoke (used for mouse rollover, etc.)
  boolean contains(float mx, float my) {
    if (dist(mx,my,x,y) < r) {
      return true;
    } else {
      return false;
    }
  }
  // Show the spoke
  void display(float mx, float my) {
    if (contains(mx,my)) {
      fill(255,255,0,123);
    } else {
      fill(255,0,0,123);
    }
    noStroke();
    rectMode(CENTER);
    rect(x,y,r,r);
  }
  void close() {
    // The spoke has a close() function to close the AudioPlayer object.
    dingdong.close(); 
  }
}
